# wxSplitterWindow Class Reference
[Miscellaneous Windows]

`#include <wx/splitter.h>`

Inheritance diagram for wxSplitterWindow:
[legend]

## Detailed Description

This class manages up to two subwindows.

The current view can be split into two programmatically (perhaps from a menu command), and unsplit either programmatically or via the wxSplitterWindow user interface.

## Styles

This class supports the following styles:

- wxSP_3D:
  Draws a 3D effect border and sash.
- wxSP_THIN_SASH:
  Draws a thin sash.
- wxSP_3DSASH:
  Draws a 3D effect sash (part of default style).
- wxSP_3DBORDER:
  Synonym for wxSP_BORDER.
- wxSP_BORDER:
  Draws a standard border.
- wxSP_NOBORDER:
  No border (default).
- wxSP_NO_XP_THEME:
  Under Windows XP, switches off the attempt to draw the splitter using Windows XP theming, so the borders and sash will take on the pre-XP look.
- wxSP_PERMIT_UNSPLIT:
  Always allow to unsplit, even with the minimum pane size other than zero.
- wxSP_LIVE_UPDATE:
  Don't draw XOR line but resize the child windows immediately.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxSplitterEvent& event)
Event macros for events emitted by this class:

- EVT_SPLITTER_SASH_POS_CHANGING(id, func):
  The sash position is in the process of being changed. May be used to modify the position of the tracking bar to properly reflect the position that would be set if the drag were to be completed at this point. Processes a `wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING` event.
- EVT_SPLITTER_SASH_POS_CHANGED(id, func):
  The sash position was changed. May be used to modify the sash position before it is set, or to prevent the change from taking place. Processes a `wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED` event.
- EVT_SPLITTER_UNSPLIT(id, func):
  The splitter has been just unsplit. Processes a `wxEVT_COMMAND_SPLITTER_UNSPLIT` event.
- EVT_SPLITTER_DCLICK(id, func):
  The sash was double clicked. The default behaviour is to unsplit the window when this happens (unless the minimum pane size has been set to a value greater than zero). Processes a `wxEVT_COMMAND_SPLITTER_DOUBLECLICKED` event.

##

Library: wxCore

Category: Miscellaneous Windows

See also:
  wxSplitterEvent, wxSplitterWindow Overview

## Public Member Functions
| wxSplitterWindow ()
| Default constructor.
| wxSplitterWindow (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxSP_3D, const wxString &name="splitterWindow")
| Constructor for creating the window.
virtual | ~wxSplitterWindow ()
| Destroys the wxSplitterWindow and its children.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &point=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxSP_3D, const wxString &name="splitter")
| Creation function, for two-step construction.
int | GetMinimumPaneSize () const
| Returns the current minimum pane size (defaults to zero).
double | GetSashGravity () const
| Returns the current sash gravity.
int | GetSashPosition () const
| Returns the current sash position.
int | GetSashSize () const
| Returns the sash size in pixels.
wxSplitMode | GetSplitMode () const
| Gets the split mode.
wxWindow * | GetWindow1 () const
| Returns the left/top or only pane.
wxWindow * | GetWindow2 () const
| Returns the right/bottom pane.
void | Initialize (wxWindow *window)
| Initializes the splitter window to have one pane.
bool | IsSplit () const
| Returns true if the window is split, false otherwise.
virtual void | OnDoubleClickSash (int x, int y)
| Application-overridable function called when the sash is double-clicked with the left mouse button.
virtual bool | OnSashPositionChange (int newSashPosition)
| Application-overridable function called when the sash position is changed by user.
virtual void | OnUnsplit (wxWindow *removed)
| Application-overridable function called when the window is unsplit, either programmatically or using the wxSplitterWindow user interface.
bool | ReplaceWindow (wxWindow *winOld, wxWindow *winNew)
| This function replaces one of the windows managed by the wxSplitterWindow with another one.
void | SetMinimumPaneSize (int paneSize)
| Sets the minimum pane size.
void | SetSashGravity (double gravity)
| Sets the sash gravity.
void | SetSashPosition (int position, bool redraw=true)
| Sets the sash position.
void | SetSplitMode (int mode)
| Sets the split mode.
virtual bool | SplitHorizontally (wxWindow *window1, wxWindow *window2, int sashPosition=0)
| Initializes the top and bottom panes of the splitter window.
virtual bool | SplitVertically (wxWindow *window1, wxWindow *window2, int sashPosition=0)
| Initializes the left and right panes of the splitter window.
bool | Unsplit (wxWindow *toRemove=NULL)
| Unsplits the window.
void | UpdateSize ()
| Causes any pending sizing of the sash and child panes to take place immediately.

List of all members.

## Constructor & Destructor Documentation

wxSplitterWindow::wxSplitterWindow | ( |  | ) |

Default constructor.

wxSplitterWindow::wxSplitterWindow | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxSP_3D`,
|  | const wxString & | name = `"splitterWindow"` |
| ) |  |  |

Constructor for creating the window.

Parameters:

  | parent | The parent of the splitter window.
  | id | The window identifier.
  | pos | The window position.
  | size | The window size.
  | style | The window style. See wxSplitterWindow.
  | name | The window name.

Remarks:
  After using this constructor, you must create either one or two subwindows with the splitter window as parent, and then call one of Initialize(), SplitVertically() and SplitHorizontally() in order to set the pane(s). You can create two windows, with one hidden when not being shown; or you can create and delete the second pane on demand.

See also:
  Initialize(), SplitVertically(), SplitHorizontally(), Create()

virtual wxSplitterWindow::~wxSplitterWindow | ( |  | ) | `[virtual]`

Destroys the wxSplitterWindow and its children.

## Member Function Documentation

bool wxSplitterWindow::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | point = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxSP_3D`,
|  | const wxString & | name = `"splitter"` |
| ) |  |  |

Creation function, for two-step construction.

See wxSplitterWindow() for details.

Reimplemented from wxWindow.

int wxSplitterWindow::GetMinimumPaneSize | ( |  | ) | const

Returns the current minimum pane size (defaults to zero).

See also:
  SetMinimumPaneSize()

double wxSplitterWindow::GetSashGravity | ( |  | ) | const

Returns the current sash gravity.

See also:
  SetSashGravity()

int wxSplitterWindow::GetSashPosition | ( |  | ) | const

Returns the current sash position.

See also:
  SetSashPosition()

int wxSplitterWindow::GetSashSize | ( |  | ) | const

Returns the sash size in pixels.

The size of the sash is its width for a vertically split window and its height for a horizontally split one. Its other direction is the same as the client size of the window in the corresponding direction.

The sash size is platform-dependent because it conforms to the current platform look-and-feel and cannot be changed.

wxSplitMode wxSplitterWindow::GetSplitMode | ( |  | ) | const

Gets the split mode.

See also:
  SetSplitMode(), SplitVertically(), SplitHorizontally().

wxWindow* wxSplitterWindow::GetWindow1 | ( |  | ) | const

Returns the left/top or only pane.

wxWindow* wxSplitterWindow::GetWindow2 | ( |  | ) | const

Returns the right/bottom pane.

void wxSplitterWindow::Initialize | ( | wxWindow * | window | ) |

Initializes the splitter window to have one pane.

The child window is shown if it is currently hidden.

Parameters:

  | window | The pane for the unsplit window.

Remarks:
  This should be called if you wish to initially view only a single pane in the splitter window.

See also:
  SplitVertically(), SplitHorizontally()

bool wxSplitterWindow::IsSplit | ( |  | ) | const

Returns true if the window is split, false otherwise.

virtual void wxSplitterWindow::OnDoubleClickSash | ( | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Application-overridable function called when the sash is double-clicked with the left mouse button.

Parameters:

  | x | The x position of the mouse cursor.
  | y | The y position of the mouse cursor.

Remarks:
  The default implementation of this function calls Unsplit if the minimum pane size is zero.

See also:
  Unsplit()

virtual bool wxSplitterWindow::OnSashPositionChange | ( | int | newSashPosition | ) | `[virtual]`

Application-overridable function called when the sash position is changed by user.

It may return false to prevent the change or true to allow it.

Parameters:

  | newSashPosition | The new sash position (always positive or zero)

Remarks:
  The default implementation of this function verifies that the sizes of both panes of the splitter are greater than minimum pane size.

virtual void wxSplitterWindow::OnUnsplit | ( | wxWindow * | removed | ) | `[virtual]`

Application-overridable function called when the window is unsplit, either programmatically or using the wxSplitterWindow user interface.

Parameters:

  | removed | The window being removed.

Remarks:
  The default implementation of this function simply hides removed. You may wish to delete the window.

bool wxSplitterWindow::ReplaceWindow | ( | wxWindow * | winOld,
|  | wxWindow * | winNew |
| ) |  |  |

This function replaces one of the windows managed by the wxSplitterWindow with another one.

It is in general better to use it instead of calling Unsplit() and then resplitting the window back because it will provoke much less flicker (if any). It is valid to call this function whether the splitter has two windows or only one.

Both parameters should be non-NULL and winOld must specify one of the windows managed by the splitter. If the parameters are incorrect or the window couldn't be replaced, false is returned. Otherwise the function will return true, but please notice that it will not delete the replaced window and you may wish to do it yourself.

See also:
  GetMinimumPaneSize()

void wxSplitterWindow::SetMinimumPaneSize | ( | int | paneSize | ) |

Sets the minimum pane size.

Parameters:

  | paneSize | Minimum pane size in pixels.

Remarks:
  The default minimum pane size is zero, which means that either pane can be reduced to zero by dragging the sash, thus removing one of the panes. To prevent this behaviour (and veto out-of-range sash dragging), set a minimum size, for example 20 pixels. If the wxSP_PERMIT_UNSPLIT style is used when a splitter window is created, the window may be unsplit even if minimum size is non-zero.

See also:
  GetMinimumPaneSize()

void wxSplitterWindow::SetSashGravity | ( | double | gravity | ) |

Sets the sash gravity.

Parameters:

  | gravity | The sash gravity. Value between 0.0 and 1.0.

Remarks:
  Gravity is real factor which controls position of sash while resizing wxSplitterWindow. Gravity tells wxSplitterWindow how much will left/top window grow while resizing. Example values:
  - 0.0: only the bottom/right window is automatically resized
  - 0.5: both windows grow by equal size
  - 1.0: only left/top window grows Gravity should be a real value between 0.0 and 1.0. Default value of sash gravity is 0.0. That value is compatible with previous (before gravity was introduced) behaviour of wxSplitterWindow.

See also:
  GetSashGravity()

void wxSplitterWindow::SetSashPosition | ( | int | position,
|  | bool | redraw = `true` |
| ) |  |  |

Sets the sash position.

Parameters:

  | position | The sash position in pixels.
  | redraw | If true, resizes the panes and redraws the sash and border.

Remarks:
  Does not currently check for an out-of-range value.

See also:
  GetSashPosition()

void wxSplitterWindow::SetSplitMode | ( | int | mode | ) |

Sets the split mode.

Parameters:

  | mode | Can be wxSPLIT_VERTICAL or wxSPLIT_HORIZONTAL.

Remarks:
  Only sets the internal variable; does not update the display.

See also:
  GetSplitMode(), SplitVertically(), SplitHorizontally().

virtual bool wxSplitterWindow::SplitHorizontally | ( | wxWindow * | window1,
|  | wxWindow * | window2,
|  | int | sashPosition = `0` |
| ) |  |  | `[virtual]`

Initializes the top and bottom panes of the splitter window.

The child windows are shown if they are currently hidden.

Parameters:

  | window1 | The top pane.
  | window2 | The bottom pane.
  | sashPosition | The initial position of the sash. If this value is positive, it specifies the size of the upper pane. If it is negative, its absolute value gives the size of the lower pane. Finally, specify 0 (default) to choose the default position (half of the total window height).

Returns:
  true if successful, false otherwise (the window was already split).

Remarks:
  This should be called if you wish to initially view two panes. It can also be called at any subsequent time, but the application should check that the window is not currently split using IsSplit().

See also:
  SplitVertically(), IsSplit(), Unsplit()

virtual bool wxSplitterWindow::SplitVertically | ( | wxWindow * | window1,
|  | wxWindow * | window2,
|  | int | sashPosition = `0` |
| ) |  |  | `[virtual]`

Initializes the left and right panes of the splitter window.

The child windows are shown if they are currently hidden.

Parameters:

  | window1 | The left pane.
  | window2 | The right pane.
  | sashPosition | The initial position of the sash. If this value is positive, it specifies the size of the left pane. If it is negative, it is absolute value gives the size of the right pane. Finally, specify 0 (default) to choose the default position (half of the total window width).

Returns:
  true if successful, false otherwise (the window was already split).

Remarks:
  This should be called if you wish to initially view two panes. It can also be called at any subsequent time, but the application should check that the window is not currently split using IsSplit().

See also:
  SplitHorizontally(), IsSplit(), Unsplit().

bool wxSplitterWindow::Unsplit | ( | wxWindow * | toRemove = `NULL` | ) |

Unsplits the window.

Parameters:

  | toRemove | The pane to remove, or NULL to remove the right or bottom pane.

Returns:
  true if successful, false otherwise (the window was not split).

Remarks:
  This call will not actually delete the pane being removed; it calls OnUnsplit() which can be overridden for the desired behaviour. By default, the pane being removed is hidden.

See also:
  SplitHorizontally(), SplitVertically(), IsSplit(), OnUnsplit()

void wxSplitterWindow::UpdateSize | ( |  | ) |

Causes any pending sizing of the sash and child panes to take place immediately.

Such resizing normally takes place in idle time, in order to wait for layout to be completed. However, this can cause unacceptable flicker as the panes are resized after the window has been shown. To work around this, you can perform window layout (for example by sending a size event to the parent window), and then call this function, before showing the top-level window.

|  | [ top ]